'use strict';
const gutil = require('gulp-util');
const PluginError = gutil.PluginError;
const through = require('through2');


var prepJsFile = function(s) {
    var c, j, l, i = 0, out = '';
    while(i<s.length) {
        if(s.substr(i, 15) == '// scope:server') {
            j = out.length-1;
            while(j>=0 && out.charAt(j) != '\n') j--;
            if(j>=0) out = out.substr(0,j+1)
            else out = '';
            i+=15
        } else 
        if(s.substr(i, 18) == '/* scope:server */') {
            i+=18;
            while(i<s.length && (c = s.charAt(i)) !='{') i++;
            l = 1;
            i++;
            while(i<s.length) {
                c = s.charAt(i)
                if(c =='{') l++;
                else
                if(c =='}') {
                    l--;
                    if(!l) break;
                }
                else
                if(c == '\n')
                    out += '\n'
                i++;
            }
            i++;
        } else
            out += s.charAt(i++)
    }
    return out;
}

module.exports = () => {
  return through.obj(function(file, enc, cb) {
    if (file.isNull()) {
      cb(null, file);
      return;
    }

    if (file.isStream()) {
      cb(new PluginError('gulp-example-plugin', 'Streaming not supported'));
      return;
    }

    try {
      file.contents = new Buffer(prepJsFile(file.contents.toString()));
      this.push(file);
    } catch (err) {
      this.emit('error', new PluginError('gulp-example-plugin', err));
    }

    cb();
  });
};